<?php

/**
 * VIP Host - Joomla Template
 *
 * @package bt_viphost
 * @version 1.0
 * @copyright BonusThemes.com 2009
 * @link http://www.bonusthemes.com/goto/bt_viphost
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * This is a file to add template specific chrome to pagination rendering.
 *
 * pagination_list_footer
 * 	Input variable $list is an array with offsets:
 * 		$list[limit]		: int
 * 		$list[limitstart]	: int
 * 		$list[total]		: int
 * 		$list[limitfield]	: string
 * 		$list[pagescounter]	: string
 * 		$list[pageslinks]	: string
 *
 * pagination_list_render
 * 	Input variable $list is an array with offsets:
 * 		$list[all]
 * 			[data]		: string
 * 			[active]	: boolean
 * 		$list[start]
 * 			[data]		: string
 * 			[active]	: boolean
 * 		$list[previous]
 * 			[data]		: string
 * 			[active]	: boolean
 * 		$list[next]
 * 			[data]		: string
 * 			[active]	: boolean
 * 		$list[end]
 * 			[data]		: string
 * 			[active]	: boolean
 * 		$list[pages]
 * 			[{PAGE}][data]		: string
 * 			[{PAGE}][active]	: boolean
 *
 * pagination_item_active
 * 	Input variable $item is an object with fields:
 * 		$item->base	: integer
 * 		$item->link	: string
 * 		$item->text	: string
 *
 * pagination_item_inactive
 * 	Input variable $item is an object with fields:
 * 		$item->base	: integer
 * 		$item->link	: string
 * 		$item->text	: string
 *
 * This gives template designers ultimate control over how pagination is rendered.
 *
 * NOTE: If you override pagination_item_active OR pagination_item_inactive you MUST override them both
 */

function pagination_list_footer($list)
{
	$html = "<div class=\"list-footer\">\n";

	$html .= "\n<div class=\"limit\">".JText::_('Display Num').$list['limitfield']."</div>";
	$html .= $list['pageslinks'];
	$html .= "\n<div class=\"counter\">".$list['pagescounter']."</div>";

	$html .= "\n<input type=\"hidden\" name=\"limitstart\" value=\"".$list['limitstart']."\" />";
	$html .= "\n</div>";

	return $html;
}


/**
 * Escapes strings to be used by JavaScript
 * 
 * @version 1.1.0.20070709
 * @author Alex Stylianos
 * @copyright Creative Pulse 2007
 * @link http://www.creativepulse.eu
 */
if (!function_exists('json_esc')) {
	function json_esc($input, $esc_lt_gt = true) {
		$result = '';
		$input = (string) $input;
		$conv = array( "'" => "'", '"' => '"', '&' => '&', '\\' => '\\', "\n" => 'n', "\r" => 'r', "\t" => 't', "\b" => 'b', "\f" => 'f' );
	
		if ($esc_lt_gt)
			$conv = array_merge($conv, array( '<' => 'u003C', '>' => 'u003E' ));
	
		for ($i = 0, $len = strlen($input); $i < $len; $i++)
			$result .= isset($conv[$input{$i}]) ? '\\' . $conv[$input{$i}] : $input{$i};
	
		return $result;
	}
}

function pagination_list_render($list) {
	$html = '';

	$e = explode("\t", $list['start']['data']);
	if ($list['start']['active'])
		$html .= '<span class="pgn_button1" onclick="window.location=\'' . json_esc($e[1]) . '\'">&laquo;</span>';
	else
		$html .= '<span class="pgn_button0">&laquo;</span>';

	$e = explode("\t", $list['previous']['data']);
	if ($list['previous']['active'])
		$html .= '<span class="pgn_button1" onclick="window.location=\'' . json_esc($e[1]) . '\'">&lt;</span>';
	else
		$html .= '<span class="pgn_button0">&lt;</span>';

	foreach ($list['pages'] as $page) {
		$e = explode("\t", $page['data']);
		if ($page['active'])
			$html .= '<span class="pgn_page" onclick="window.location=\'' . json_esc($e[1]) . '\'">' . $e[0] . '</span>';
		else
			$html .= '<span class="pgn_current">' . $e[0] . '</span>';
	}

	$e = explode("\t", $list['next']['data']);
	if ($list['next']['active'])
		$html .= '<span class="pgn_button1" onclick="window.location=\'' . json_esc($e[1]) . '\'">&gt;</span>';
	else
		$html .= '<span class="pgn_button0">&gt;</span>';

	$e = explode("\t", $list['end']['data']);
	if ($list['end']['active'])
		$html .= '<span class="pgn_button1" onclick="window.location=\'' . json_esc($e[1]) . '\'">&raquo;</span>';
	else
		$html .= '<span class="pgn_button0">&raquo;</span>';

	return $html;
}

function pagination_item_active(&$item) {
	return $item->text . "\t" . $item->link;
}

function pagination_item_inactive(&$item) {
	return $item->text;
}

?>