<?php

/**
 * VIP Host - Joomla Template
 *
 * @package bt_viphost
 * @version 1.0
 * @copyright BonusThemes.com 2009
 * @link http://www.bonusthemes.com/goto/bt_viphost
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

function BtMenuVMNewItem($base, $name, $link) {
	$result = new stdClass();
	$result->parent = $base;
	$result->is_active = false;
	$result->selection = 0;
	$result->type = 'link';
	$result->link = $link;
	$result->href = '';
	$result->name = $name;
	$result->image = '';
	$result->sub_menu_items = array();
	return $result;
}

class BtMenuVMCategory {

	function BtMenuVMCategory($id, $name, $publish, $vendor_id) {
		$this->__construct($id, $name, $publish, $vendor_id);
	}

	function __construct($id, $name, $published, $vendor_id) {
		$this->id = $id;
		$this->parent_id = null;
		$this->name = $name;
		$this->published = $published;
		$this->vendor_id = $vendor_id;
		$this->sub_items = array();
	}

	function read($base, $instance, $published, $cur_vendor, $depth) {
		global $btMenuVMCategories, $sess;
		$result = array();

		if ($this->id != '0')
			$result['vmcat_' . $instance . '_' . $this->id] = BtMenuVMNewItem(
				$this->parent_id == '0' ? $base : 'vmcat_' . $instance . '_' . $this->parent_id,
				$this->name,
				$sess->url(URL . 'index.php?page=shop.browse&amp;category_id=' . $this->id)
			);

		foreach ($this->sub_items as $id) {
			if ($published && !$btMenuVMCategories[$id]->published)
				continue;

			if ($cur_vendor && $btMenuVMCategories[$id]->vendor_id != $_SESSION['ps_vendor_id'])
				continue;

			if ($depth == 1)
				continue;

			$res = $btMenuVMCategories[$id]->read($base, $instance, $published, $cur_vendor, $depth - 1);
			foreach ($res as $k => $v)
				$result[$k] = $v;
		}

		return $result;
	}

}

class BtMenuVMLoader {

	function BtMenuVMLoader() {
		$this->__construct();
	}

	function __construct() {
		global $btMenuVMCategories;
		$btMenuVMCategories = null;
	}

	function load_items($base, $instance, $q) {
		global $sess, $mm_action_url;

		require_once(CLASSPATH . 'ps_product.php');
		$ps_product = new ps_product;

		require_once(CLASSPATH . 'ps_product_category.php');
		$ps_product_category = new ps_product_category;

		$db = new ps_DB;
		$db->query($q);

		$i = 0;
		while ($db->next_record()) {
			$i++;
			$product_id = $db->f("product_id");
			$cid = $ps_product_category->get_cid($product_id);
		
			if ($db->f("product_parent_id")) {
				$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_parent_id"));
				$url .= "&product_id=" . $db->f("product_parent_id");
			} else {
				$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_id"));
				$url .= "&product_id=" . $db->f("product_id");
			}

			$this->result['vm_' . $instance . '_' . $i] = BtMenuVMNewItem($base, $db->f("product_name"), $sess->url($mm_action_url . 'index.php' . $url));
		}
	}

	function load($base, $link) {
		$this->result = array();
		$elements = explode(':', $link);

		$vars = array();
		for ($i = 3, $len = count($elements); $i < $len; $i++) {
			$e = explode('=', $elements[$i], 2);
			if (count($e) == 2)
				$vars[strtolower($e[0])] = $e[1];
		}

		$db = new ps_DB;

		static $instance = 0;

		switch ($elements[2]) {
			case 'category':
				global $btMenuVMCategories;
				if ($btMenuVMCategories === null) {
					$btMenuVMCategories = array('0' => new BtMenuVMCategory('0', '', true, '', '', $_SESSION['ps_vendor_id']));

					$q = "SELECT category_id, category_name, category_publish, vendor_id FROM #__{vm}_category ORDER BY list_order ASC, category_name ASC";
					$db->query($q);
					while ($db->next_record())
						$btMenuVMCategories[$db->f("category_id")] = new BtMenuVMCategory($db->f("category_id"), $db->f("category_name"), $db->f("category_publish"), $db->f("vendor_id"));

					$q = "SELECT category_parent_id, category_child_id FROM #__{vm}_category_xref";
					$db->query($q);
					while ($db->next_record()) {
						if (isset($btMenuVMCategories[$db->f("category_child_id")]))
							$btMenuVMCategories[$db->f("category_child_id")]->parent_id = $db->f("category_parent_id");

						if (isset($btMenuVMCategories[$db->f("category_parent_id")]))
							$btMenuVMCategories[$db->f("category_parent_id")]->sub_items[] = $db->f("category_child_id");
					}
				}

				$published = isset($vars['published']) ? $vars['published'] == '1' : true;
				$cur_vendor = isset($vars['cur_vendor']) ? $vars['cur_vendor'] == '1' : true;
				$id = isset($vars['id']) ? $vars['id'] : '0';
				$depth = isset($vars['depth']) ? (int) $vars['depth'] : 0;

				if ($depth > 0)
					$depth++;

				preg_match_all('/[0-9]+/', $id, $cat_ids);
				if (!empty($cat_ids[0])) {
					$instance++;
					foreach ($cat_ids[0] as $id)
						if (isset($btMenuVMCategories[$id]))
							$this->result = $btMenuVMCategories[$id]->read($base, $instance, $published, $cur_vendor, $depth);
				}

				break;

			case 'featured':
				$cur_vendor = isset($vars['cur_vendor']) ? $vars['cur_vendor'] == '1' : true;

				$max_items = isset($vars['max']) ? (int) $vars['max'] : 0;
				if ($max_items <= 0)
					$max_items = 10;

				$cat = isset($vars['cat']) ? $vars['cat'] : '';
				preg_match_all('/[0-9]+/', $cat, $cat_ids);

				$q = "SELECT DISTINCT p.product_sku FROM #__{vm}_product p" . (empty($cat_ids[0]) ? "" : ", #__{vm}_product_category_xref l")
					. " WHERE p.product_parent_id = 0"
					. " AND p.product_special = 'Y'"
					. " AND p.product_publish = 'Y'"
					. ($cur_vendor ? " AND p.vendor_id = '{$_SESSION['ps_vendor_id']}'" : "")
					. (CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1" ? " AND p.product_in_stock > 0 " : "")
					. (empty($cat_ids[0]) ? "" : " AND p.product_id = l.product_id AND l.category_id IN (" . implode(",", $cat_ids[0]) . ")")
					. " ORDER BY RAND()"
					. " LIMIT 0, $max_items";
				$db->query($q);

				if ($db->num_rows() > 0) {
					$instance++;

					$skus = array();
					while ($db->next_record())
						$skus[] = $db->getEscaped($db->f("product_sku"));
					$q = "SELECT product_id, product_name, product_parent_id FROM #__{vm}_product WHERE product_sku IN ('" . implode("','", $skus) . "')";

					$this->load_items($base, $instance, $q);
				}

				break;

			case 'latest':
				$cur_vendor = isset($vars['cur_vendor']) ? $vars['cur_vendor'] == '1' : true;

				$max_items = isset($vars['max']) ? (int) $vars['max'] : 0;
				if ($max_items <= 0)
					$max_items = 10;

				$cat = isset($vars['cat']) ? $vars['cat'] : '';
				preg_match_all('/[0-9]+/', $cat, $cat_ids);

				$q = "SELECT DISTINCT p.product_sku FROM #__{vm}_product p" . (empty($cat_ids[0]) ? "" : ", #__{vm}_product_category_xref l")
					. " WHERE p.product_parent_id = 0"
					. " AND p.product_publish = 'Y'"
					. ($cur_vendor ? " AND p.vendor_id = '{$_SESSION['ps_vendor_id']}'" : "")
					. (CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1" ? " AND p.product_in_stock > 0 " : "")
					. (empty($cat_ids[0]) ? "" : " AND p.product_id = l.product_id AND l.category_id IN (" . implode(",", $cat_ids[0]) . ")")
					. " ORDER BY p.product_id DESC"
					. " LIMIT 0, $max_items";
				$db->query($q);

				if ($db->num_rows() > 0) {
					$instance++;

					$skus = array();
					while ($db->next_record())
						$skus[] = $db->getEscaped($db->f("product_sku"));
					$q = "SELECT product_id, product_name, product_parent_id FROM #__{vm}_product WHERE product_sku IN ('" . implode("','", $skus) . "')";

					$this->load_items($base, $instance, $q);
				}

				break;

			case 'random':
				$cur_vendor = isset($vars['cur_vendor']) ? $vars['cur_vendor'] == '1' : true;

				$max_items = isset($vars['max']) ? (int) $vars['max'] : 0;
				if ($max_items <= 0)
					$max_items = 10;

				$cat = isset($vars['cat']) ? $vars['cat'] : '';
				preg_match_all('/[0-9]+/', $cat, $cat_ids);

				$q = "SELECT DISTINCT p.product_sku FROM #__{vm}_product p" . (empty($cat_ids[0]) ? "" : ", #__{vm}_product_category_xref l")
					. " WHERE p.product_parent_id = 0"
					. " AND p.product_publish = 'Y'"
					. ($cur_vendor ? " AND p.vendor_id = '{$_SESSION['ps_vendor_id']}'" : "")
					. (CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1" ? " AND p.product_in_stock > 0 " : "")
					. (empty($cat_ids[0]) ? "" : " AND p.product_id = l.product_id AND l.category_id IN (" . implode(",", $cat_ids[0]) . ")")
					. " ORDER BY RAND()"
					. " LIMIT 0, $max_items";
				$db->query($q);

				if ($db->num_rows() > 0) {
					$instance++;

					$skus = array();
					while ($db->next_record())
						$skus[] = $db->getEscaped($db->f("product_sku"));
					$q = "SELECT product_id, product_name, product_parent_id FROM #__{vm}_product WHERE product_sku IN ('" . implode("','", $skus) . "')";

					$this->load_items($base, $instance, $q);
				}

				break;

			case 'selected':
				if (!empty($vars['id'])) {
					preg_match_all('/[0-9]+/', $vars['id'], $prd_ids);
					if (!empty($prd_ids[0])) {
						$instance++;

						$q = "SELECT product_id, product_name, product_parent_id FROM #__{vm}_product WHERE product_id IN ('" . implode("','", $prd_ids[0]) . "')";

						$this->load_items($base, $instance, $q);
					}
				}
				break;

			case 'topten':
				$cur_vendor = isset($vars['cur_vendor']) ? $vars['cur_vendor'] == '1' : true;

				$max_items = isset($vars['max']) ? (int) $vars['max'] : 0;
				if ($max_items <= 0)
					$max_items = 10;

				$cat = isset($vars['cat']) ? $vars['cat'] : '';
				preg_match_all('/[0-9]+/', $cat, $cat_ids);

				$q = "SELECT DISTINCT p.product_sku FROM #__{vm}_product p" . (empty($cat_ids[0]) ? "" : ", #__{vm}_product_category_xref l")
					. " WHERE p.product_parent_id = 0"
					. " AND p.product_publish = 'Y'"
					. ($cur_vendor ? " AND p.vendor_id = '{$_SESSION['ps_vendor_id']}'" : "")
					. (CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1" ? " AND p.product_in_stock > 0 " : "")
					. " AND p.product_sales > 0"
					. (empty($cat_ids[0]) ? "" : " AND p.product_id = l.product_id AND l.category_id IN (" . implode(",", $cat_ids[0]) . ")")
					. " ORDER BY p.product_sales DESC, p.product_name"
					. " LIMIT 0, $max_items";
				$db->query($q);

				if ($db->num_rows() > 0) {
					$instance++;

					$skus = array();
					while ($db->next_record())
						$skus[] = $db->getEscaped($db->f("product_sku"));
					$q = "SELECT product_id, product_name, product_parent_id FROM #__{vm}_product WHERE product_sku IN ('" . implode("','", $skus) . "')";

					$this->load_items($base, $instance, $q);
				}

				break;
		}

		return $this->result;
	}

}

?>